// Copyright 2015-2020 SWIM.AI inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * Signing and encryption of <strong>swim-structure</strong> values using the
 * JSON Web Key (JWK), JSON Web Signature (JWS), JSON Web Token (JWT), and
 * OpenID standards.
 */
module swim.security {
  requires swim.util;
  requires transitive swim.codec;
  requires transitive swim.structure;
  requires transitive swim.recon;
  requires transitive swim.json;
  requires transitive swim.collections;

  exports swim.security;
}
