// Copyright 2015-2020 SWIM.AI inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

export {
  InletType,
  InletOptions,
  Inlet,
} from "./Inlet";
export {
  OutletType,
  OutletOptions,
  Outlet,
} from "./Outlet";
export {
  InoutletType,
  InoutletOptions,
  Inoutlet,
} from "./Inoutlet";

export {KeyEffect} from "./KeyEffect";
export {MapInlet} from "./MapInlet";
export {MapOutlet} from "./MapOutlet";
export {MapInoutlet} from "./MapInoutlet";
export {MapInletOutlet} from "./MapInletOutlet";
export {MapInletMapOutlet} from "./MapInletMapOutlet";

export {StreamletException} from "./StreamletException";
export {StreamletContext} from "./StreamletContext";
export {StreamletScope} from "./StreamletScope";
export {Streamlet} from "./Streamlet";
export {GenericStreamlet} from "./GenericStreamlet";

export {AbstractInlet} from "./AbstractInlet";
export {AbstractOutlet} from "./AbstractOutlet";
export {AbstractInoutlet} from "./AbstractInoutlet";

export {KeyOutlet} from "./KeyOutlet";
export {AbstractMapInlet} from "./AbstractMapInlet";
export {AbstractMapOutlet} from "./AbstractMapOutlet";
export {AbstractMapInoutlet} from "./AbstractMapInoutlet";
export {AbstractMapInletOutlet} from "./AbstractMapInletOutlet";
export {AbstractMapInletMapOutlet} from "./AbstractMapInletMapOutlet";

export {OutletInlet} from "./OutletInlet";
export {OutletMapInlet} from "./OutletMapInlet";

export {ValueInput} from "./ValueInput";
export {ValueOutput} from "./ValueOutput";

export {MapInput} from "./MapInput";
export {MapOutput} from "./MapOutput";

export * from "./function";

export * from "./combinator";

export {
  InletDescriptor,
  OutletDescriptor,
  StreamletClass,
  AbstractStreamlet,
} from "./AbstractStreamlet";
export {StreamletInlet} from "./StreamletInlet";
export {StreamletOutlet} from "./StreamletOutlet";
export {StreamletInoutlet} from "./StreamletInoutlet";
export {In} from "./In";
export {Out} from "./Out";
export {Inout} from "./Inout";
